"""Stub file for reflex/components/base/link.py"""

# ------------------- DO NOT EDIT ----------------------
# This file was generated by `reflex/utils/pyi_generator.py`!
# ------------------------------------------------------
from collections.abc import Mapping, Sequence
from typing import Any, overload

from reflex.components.component import Component
from reflex.components.core.breakpoints import Breakpoints
from reflex.event import EventType
from reflex.vars.base import Var

class RawLink(Component):
    @overload
    @classmethod
    def create(  # type: ignore
        cls,
        *children,
        href: Var[str] | str | None = None,
        rel: Var[str] | str | None = None,
        style: Sequence[Mapping[str, Any]]
        | Mapping[str, Any]
        | Var[Mapping[str, Any]]
        | Breakpoints
        | None = None,
        key: Any | None = None,
        id: Any | None = None,
        class_name: Any | None = None,
        autofocus: bool | None = None,
        custom_attrs: dict[str, Var | Any] | None = None,
        on_blur: EventType[()] | None = None,
        on_click: EventType[()] | None = None,
        on_context_menu: EventType[()] | None = None,
        on_double_click: EventType[()] | None = None,
        on_focus: EventType[()] | None = None,
        on_mount: EventType[()] | None = None,
        on_mouse_down: EventType[()] | None = None,
        on_mouse_enter: EventType[()] | None = None,
        on_mouse_leave: EventType[()] | None = None,
        on_mouse_move: EventType[()] | None = None,
        on_mouse_out: EventType[()] | None = None,
        on_mouse_over: EventType[()] | None = None,
        on_mouse_up: EventType[()] | None = None,
        on_scroll: EventType[()] | None = None,
        on_unmount: EventType[()] | None = None,
        **props,
    ) -> RawLink:
        """Create the component.

        Args:
            *children: The children of the component.
            href: The href.
            rel: The type of link.
            style: The style of the component.
            key: A unique key for the component.
            id: The id for the component.
            class_name: The class name for the component.
            autofocus: Whether the component should take the focus once the page is loaded
            custom_attrs: custom attribute
            **props: The props of the component.

        Returns:
            The component.
        """
        ...

class ScriptTag(Component):
    @overload
    @classmethod
    def create(  # type: ignore
        cls,
        *children,
        type_: Var[str] | str | None = None,
        source: Var[str] | str | None = None,
        integrity: Var[str] | str | None = None,
        crossorigin: Var[str] | str | None = None,
        referrer_policy: Var[str] | str | None = None,
        is_async: Var[bool] | bool | None = None,
        defer: Var[bool] | bool | None = None,
        style: Sequence[Mapping[str, Any]]
        | Mapping[str, Any]
        | Var[Mapping[str, Any]]
        | Breakpoints
        | None = None,
        key: Any | None = None,
        id: Any | None = None,
        class_name: Any | None = None,
        autofocus: bool | None = None,
        custom_attrs: dict[str, Var | Any] | None = None,
        on_blur: EventType[()] | None = None,
        on_click: EventType[()] | None = None,
        on_context_menu: EventType[()] | None = None,
        on_double_click: EventType[()] | None = None,
        on_focus: EventType[()] | None = None,
        on_mount: EventType[()] | None = None,
        on_mouse_down: EventType[()] | None = None,
        on_mouse_enter: EventType[()] | None = None,
        on_mouse_leave: EventType[()] | None = None,
        on_mouse_move: EventType[()] | None = None,
        on_mouse_out: EventType[()] | None = None,
        on_mouse_over: EventType[()] | None = None,
        on_mouse_up: EventType[()] | None = None,
        on_scroll: EventType[()] | None = None,
        on_unmount: EventType[()] | None = None,
        **props,
    ) -> ScriptTag:
        """Create the component.

        Args:
            *children: The children of the component.
            type_: The type of script represented.
            source: The URI of an external script.
            integrity: Metadata to verify the content of the script.
            crossorigin: Whether to allow cross-origin requests.
            referrer_policy: Indicates which referrer to send when fetching the script.
            is_async: Whether to asynchronously load the script.
            defer: Whether to defer loading the script.
            style: The style of the component.
            key: A unique key for the component.
            id: The id for the component.
            class_name: The class name for the component.
            autofocus: Whether the component should take the focus once the page is loaded
            custom_attrs: custom attribute
            **props: The props of the component.

        Returns:
            The component.
        """
        ...
